Package: groovy.util

## [Java] Class DelegatingScript

- groovy.util.DelegatingScript

- Script that performs method invocations and property access like Closure does.

  DelegatingScript is a convenient basis for loading a custom-defined DSL as a Script, then execute it. The following sample code illustrates how to do it:

       class MyDSL {
           public void foo(int x, int y, Closure z) { ... }
           public void setBar(String a) { ... }
       }

       CompilerConfiguration cc = new CompilerConfiguration();
       cc.setScriptBaseClass(DelegatingScript.class.getName());
       GroovyShell sh = new GroovyShell(cl,new Binding(),cc);
       DelegatingScript script = (DelegatingScript)sh.parse(new File("my.dsl"))
       script.setDelegate(new MyDSL());
       script.run();

  `my.dsl` can look like this:

       foo(1,2) {
           ....
       }
       bar = ...;

  DelegatingScript does this by delegating property access and method invocation to the `delegate` object.

  More formally speaking, given the following script:

       a = 1;
       b(2);

  Using DelegatingScript as the base class, the code will run as:

       delegate.a = 1;
       delegate.b(2);

  ... whereas in plain Script, this will be run as:

       binding.setProperty("a",1);
       ((Closure)binding.getProperty("b")).call(2);

- - ### Constructor Summary

    Constructors
    Constructor and description
    `protected DelegatingScript ()`
    `protected DelegatingScript (Binding binding)`

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `Object` | `getDelegate()`
    `` | `Object` | `getProperty(String property)`
    `` | `Object` | `invokeMethod(String name, Object args)`
    `` | `void` | `setDelegate(Object delegate)` Sets the delegation target.
    `` | `void` | `setProperty(String property, Object newValue)`

- - ### Constructor Detail

    - #### protected DelegatingScript()

    - #### protected DelegatingScript(Binding binding)

  - ### Method Detail

    - #### public Object getDelegate()

    - #### @com.github.javaparser.ast.expr.MarkerAnnotationExprOverride public Object getProperty(String property)

    - #### @com.github.javaparser.ast.expr.MarkerAnnotationExprOverride public Object invokeMethod(String name, Object args)

    - #### public void setDelegate(Object delegate)

      Sets the delegation target.

    - #### @com.github.javaparser.ast.expr.MarkerAnnotationExprOverride public void setProperty(String property, Object newValue)